package helper;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

public class UtilityTest {

    private Date d140317;
    private Date start;
    private Calendar c;
    private Date ende;

    @BeforeEach
    public void setUp() throws Exception {
      c = new GregorianCalendar();
      c.set(2014, 2, 17); // Januar ist Monat 0
      d140317 = c.getTime();
  }

    @Test
    public void testDauer00fehler() {
        c.set(2014, 2, 16);
        ende = c.getTime();
        try {
          Utility.dauer(d140317, ende);
          Assertions.fail();
        } catch (IllegalArgumentException e) {
          e.printStackTrace();
        }
    }

    @Test
    public void testDauer01() {
        int dauer = Utility.dauer(d140317, d140317);
        Assertions.assertTrue(1 == dauer
            , "erwartet: 1 gefunden: " + dauer);
    }

    @Test
    public void testDauer02() {
        c.set(2014, 2, 21);
        ende = c.getTime();
        int dauer = Utility.dauer(d140317, ende);
        Assertions.assertTrue(5 == dauer
            , "erwartet: 5 gefunden: " + dauer);
    }

    @Test
    public void testDauer03() {
        c.set(2014, 2, 22);
        ende = c.getTime();
        int dauer = Utility.dauer(d140317, ende);
        Assertions.assertTrue(5 == dauer
            , "erwartet: 5 gefunden: " + dauer);
    }

    @Test
    public void testDauer04() {
        c.set(2014, 2, 23);
        ende = c.getTime();
        int dauer = Utility.dauer(d140317, ende);
        Assertions.assertTrue(5 == dauer
            , "erwartet: 5 gefunden: " + dauer);
    }

    @Test
    public void testDauer05() {
        c.set(2014, 2, 24);
        ende = c.getTime();
        int dauer = Utility.dauer(d140317, ende);
        Assertions.assertTrue(6 == dauer
            , "erwartet: 6 gefunden: " + dauer);
    }

    @Test
    public void testDauer06() {
        c.set(2014, 2, 14);
        start = c.getTime();
        int dauer = Utility.dauer(start, d140317);
        Assertions.assertTrue(2 == dauer
            , "erwartet: 2 gefunden: " + dauer);
    }

    @Test
    public void testDauer07() {
        c.set(2014, 2, 15);
        start = c.getTime();
        int dauer = Utility.dauer(start, d140317);
        Assertions.assertTrue(1 == dauer
            , "erwartet: 1 gefunden: " + dauer);
    }

    @Test
    public void testDauer08() {
        c.set(2014, 2, 15);
        start = c.getTime();
        int dauer = Utility.dauer(start, start);
        Assertions.assertTrue(0 == dauer
            , "erwartet: 0 gefunden: " + dauer);
    }

    @Test
    public void testDauer09() {
        c.set(2014, 2, 16);
        start = c.getTime();
        int dauer = Utility.dauer(start, d140317);
        Assertions.assertTrue(1 == dauer
            , "erwartet: 1 gefunden: " + dauer);
    }

    @Test
    public void testDauer10() {
        c.set(2014, 2, 1);
        start = c.getTime();
        c.set(2014, 2, 30);
        ende = c.getTime();
        int dauer = Utility.dauer(start, ende);
        Assertions.assertTrue(20 == dauer
            , "erwartet: 20 gefunden: " + dauer);
    }

    @Test
    public void testDauer11() {
        c.set(2014, 2, 1);
        start = c.getTime();
        c.set(2015, 1, 28);
        ende = c.getTime();
        int dauer = Utility.dauer(start, ende);
        Assertions.assertTrue(260 == dauer
            , "erwartet: 260 gefunden: " + dauer);
    }

    @Test
    public void testDauer12() {
        c.set(2015, 2, 1);
        start = c.getTime();
        c.set(2016, 1, 29);
        ende = c.getTime();
        int dauer = Utility.dauer(start, ende);
        Assertions.assertTrue(261 == dauer
            , "erwartet: 261 gefunden: " + dauer);
    }
}
